############################################################################  
#                                                                           #
# File for the definition of morphological variations                       #
#                                                                           #
#############################################################################  

##########LAST UPDATE 27/10/2004








##################################################################
# RULE DEFINITION:
# CASE 1 : variation upon lemma1
# CASE 2 : variation upon lemma2
# CASE 3 : cross-variation 
#
# FORMAT: POS PATTERN, 'SPLIT PATTERN', 'NEW LEMMA', RULE TABULAR, EXCEPTIONS, OUTPUT FILES
#
# POS PATTERN: bit mask:   na 1 ; npn 2 ; npna 4 ; nv 8 ; nn 16 ; npnpn 32 ; npnn, npnng 64;
# SPLIT PATTERN:  regular expression to split affix and stem 
# NEW LEMMA: computing of the new lemma thanks to tge split pattern
# RULE TABULAR: list of pairs ("affix", "newaffix"). If no rules, use the tabular  @NULL
# EXCEPTIONS : exception tabular indexed by affix 
# OUTPUT FILES
#
#
# VARIABLES: _AFFIXE_ : affix that initiates the rule
#            _NEWAFFIXE_ : derivational affix
#            _V1_ :  $1 of the regular expression
#            _V2_ :  $2 of the regular expression
#            _V3_ :  $3 of the regular expression 
############################################################



%CAS1= (
	prefixe => [0, '^(_AFFIXE_)-?(.+)$', '_V2_', \@TPrefixe , 0, SORTIE6 ],
	tiret => [0, '^(.+)-(.+)$', '_V1__V2_', \@NULL , 0, SORTIE5 ],
	suffens => [0, '^(.+)(_AFFIXE_)$', '_V1__NEWAFFIXE_', \@TSuffEns , 0, SORTIE8],
	suffs1 => [0, '^(.*)(_AFFIXE_)$', '_V1__NEWAFFIXE_', \@TSuffS1 , 0, SORTIE8 ]
    );

%CAS2= (
	prefixe => [0, '^(_AFFIXE_)-?(.+)$', '_V2_', \@TPrefixe , \%EXEPTION_PREF, SORTIE6 ],
	tiret => [0, '^(.+)-(.+)$', '_V1__V2_', \@NULL , 0, SORTIE5 ],
	adjrel => [1, '^(.*)(_AFFIXE_)$', '_V1__NEWAFFIXE_', \@TMorphAdjRel ,\%EXEPTION_SUFF_REL, SORTIE4 ],
	);

%CAS3= (
	suffinv => [0, '^(..+)(_AFFIXE_)$', '_V1__NEWAFFIXE_', \@TSuffInv , 0, SORTIE7 ]
	);


#########################################"
# RULE TABULAR
# each rule follows the syntax: [_AFFIXE_, _NEWAFFIXE_ ]

#NULL RULE
@NULL = (["",""]);



# tableau contenant les variations morphologiques
# pour chaque suffixe d'adjectif en premier champ, le tableau fournit
# le suffixe de nom equivalent en deuxieme champ 


@TMorphAdjRel = (
#ic
    ["ic",""],
#ous
    ["aceous",""],
    ["eous",""],
    ["ous",""],
#al
   ["inal","e"],
   ["ial",""],
   ["ial","e"],
   ["ial","y"],
#an
["ian",""]
    ) ; 



#PREFIXE
@TPrefixe = ( ["ab",""],
["agro",""], ["anti",""], ["auto",""], ["bi",""], ["bio",""], ["co",""], ["de",""], ["dis",""], ["extra",""], ["hemi",""], ["hyper",""], ["hypo",""], ["il",""], ["im",""], ["in",""], ["infra",""], ["inter",""], ["ir",""], ["macro",""], ["meta",""], ["micro",""], ["mini",""], ["mono",""], ["multi",""], ["neo",""], ["non",""], ["para",""], ["peri",""], ["post",""], ["pre",""], ["pro",""], ["pseudo",""], ["quasi",""], ["re",""], ["retro",""], ["semi",""], ["sub",""], ["super",""], ["supra",""],  ["tele",""], ["trans",""], ["tri",""], ["ultra",""], ["un",""], ["under",""]) ;

#Nom typique du 1er actant : transport/transporteur


@TSuffS1 = (
#ee
    ["ee",""],
#or
    ["or","ion"]
    ) ; 

#SUFFENS
@TSuffEns = (
#age
    ["age","e"],
    ["age",""],
#ing
    ["ing",""]
    ) ; 


#Traitement morphologique des inversions refletant "action de V"


@TSuffInv = (
    #ation
    ["ation","ed"],
    #ion
    ["ion","ed"]
    ) ; 


